#include <iostream>
long long modul = 1000000007;
using namespace std;
long long Proizvod(int i , long long N,long long x)
{
    return(((N -i)% modul )* ((i +1)%modul)  *((x) % modul))%modul;
}
int main()
{
    long long N , k;
    cin >> N >> k;
    long long a[N];
    long long zbir=0;
    if( k == 1)
    {

    for(int i = 0; i<N; i++)
    {
        cin >> a[i];
        zbir=( zbir +Proizvod(i,N,a[i])) % modul;
    }


    }
     else
     {
         for(int i = 0; i<N; i++)
         {
            cin >> a[i];
            zbir += a[i];
         }
     }


 cout << zbir;
    return 0;
}